
#ifdef __BORLANDC__
	// Borland stuff.
	#include <condefs.h>
	#include <windows.h>
	#pragma hdrstop
#endif

#include <Alert.h>//jun
#include <Application.h>//jun


//*************************************************************************************
//
// This is intended to demonstrate bone-based mesh deformation (Forward Kinematics).
// Right now, I only have 'tentacle'-style bones in and working.  I'll add the 'human
// finger with knuckles' in the next release.  Note, the math is sort of 'cheatish'
// in this version (approximating with quadratics).
//
// Issues:
// - Not managing RAM very well, not freeing on exit (it's just a beta, RIGHT?!).
// - No decent error handling on file-loader boky.
// - HORRIBLY, INSANELY inefficient vectors of classes shit in the display loop.
// - The bone ops are done with f00-ishly calculated icky quadratics, this creates
//   C2 discontinuities and such, need to rewrite to use BSplines instead.
// - Nothing is commented the way it should be (especially that math stuff).
// - The LinkInfo and related classes are still just hacked in ... not pretty.
// - No class structure support for virtual LinkInfo-type shit.
//
//*************************************************************************************



#if __BORLANDC__ >= 0x0530

// Here's some stuff my compiler wants.  Ignore it and you will still be okay.  ;-)
// Just make sure you build with all the sources....

// This pragma eliminates the compiler-restart due to the asm block, below.
#pragma inline
USELIB("glut32.lib");
USEUNIT("f00TargaLoader.cpp");
USEUNIT("f00TextureObject.cpp");
USEUNIT("f00ImageLoader.cpp");
USEUNIT("f00FileLoader.cpp");
USEUNIT("f00RGBA.cpp");
USEUNIT("f00TimeBase.cpp");
USEUNIT("f00QuatObject.cpp");
USEUNIT("f00Quat.cpp");
USEUNIT("f00QuatCamera.cpp");
USEUNIT("f00Point3D.cpp");
USEUNIT("f00BoneSystem.cpp");
USEUNIT("f00Tentacle.cpp");
//---------------------------------------------------------------------------
#endif


#ifdef _MSC_VER
// MS compiler stuff here.
#include <windows.h>
#endif


// System includes.
#include <GL/gl.h>
#include <GL/glut.h>
#include <math.h>
#include <cstdio>

// Local includes.
#include "f00PI.h"
#include "f00TargaLoader.h"
#include "f00TextureObject.h"
#include "f00TimeBase.h"
#include "f00QuatCamera.h"

#include "f00BoneSystem.h"
#include "f00Tentacle.h"
#include "f00TextureObject.h"
#include "f00TargaLoader.h"



// Yup, more globals....
f00QuatCamera					d_camera;

int								d_mainWindowID = 0;
f00TimeBase						d_timeBase( 1000 );		// 1.0 second 'time-frame'.

f00TextureObject*				d_pTexture;

f00Tentacle*					d_pTentacle1 = 0;
f00Tentacle*					d_pTentacle2 = 0;
f00Tentacle*					d_pTentacle3 = 0;
f00Tentacle*					d_pTentacle4 = 0;
f00Tentacle*					d_pTentacle5 = 0;
f00BoneSystem*					d_pBoneSystem = 0;

bool								d_autoRotate = true;
GLfloat							d_viewAngle = 0.0;
GLfloat							d_autoViewAngle = 0.0;

char path[B_PATH_NAME_LENGTH];//jun

// LlamaPrototypes....
void
uninit();



void
processExitKey()
{
	uninit();

	glutDestroyWindow( d_mainWindowID );
	d_mainWindowID = 0;

	// SIGH!  This is the 'correct' way to exit GLUT.  Oh well.
	exit( 0 );
}


// This is called each 'frame'.
void
displayFunc()
{
	char datapath[B_PATH_NAME_LENGTH] = "";//jun
	char *dest;//jun

	// If first time in, setup stuff.
	if( d_pBoneSystem == 0 )
	{
		f00TargaLoader targaLoader;
//jun begin
		dest = strrchr(path,'/');
		strncpy(datapath, path, dest - path + 1);
		strcat(datapath , "tentacle.tga");
		if (!targaLoader.loadImageFromFile( datapath ))
		{
			(new BAlert("","Missing...tentacle.tga","OK"))->Go();
			exit(0);
		}
//jun end

		d_pTexture = new f00TextureObject( targaLoader );

		d_pTentacle1 = new f00Tentacle( d_pTexture, 5, 5, 2, 8, 1.0, 20.0, 0.7, 0.6 );		// Whippit
		d_pTentacle2 = new f00Tentacle( d_pTexture, 2, 3, 5, 8, 3.0, 20.0, 1.0, 1.0 );		// Stumpy
		d_pTentacle3 = new f00Tentacle( d_pTexture, 4, 3, 5, 8, 1.0, 20.0, 0.5, 1.0 );		// Stubby
		d_pTentacle4 = new f00Tentacle( d_pTexture, 2, 6, 5, 16, 1.0, 20.0, 0.5, 1.0 );		// Minimalistic
		d_pTentacle5 = new f00Tentacle( d_pTexture, 16, 16, 7, 16, 1.0, 20.0, 0.8, 0.9 );	// Crusher

		d_pBoneSystem = d_pTentacle1;
	}

	// Clear the various buffers.
	glClearColor( 0.3, 0.3, 0.3, 0.0 );
	glClear( GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT );

	// Update the timebase.
	d_timeBase.updateFrameValues();
	GLfloat lastFrameDeltaSeconds( d_timeBase.getLastFrameDelta() );


#ifdef _WIN32
// FPS hack
static int frameCount( 0 );
static std::vector< int > frameTick;
if( frameCount == 10 )
	frameTick.pop_back();
else
	frameCount++;
frameTick.insert( frameTick.begin(), GetTickCount() );
if( frameCount > 1 )
{
	float fpsVal( frameCount / ( float( frameTick[ 0 ] - frameTick[ frameTick.size() - 1 ] ) / 1000.0 ) );
	printf( "Frames: %2d  FPS: %.2f \n", frameCount, fpsVal );
}
#endif

	// Reset the model/view matrix to default.
	glMatrixMode( GL_MODELVIEW_MATRIX );
	glLoadIdentity();

	// Update the camera.  (So it doesn't move after all ... sue me.)
	float cameraThetaRad( 135.0 * M_PI / 180.0 );
	d_camera.moveTo( sin( cameraThetaRad ) * 20.0, 0.0, cos( cameraThetaRad ) * 20.0 );
	d_camera.pointAt( 0.0, 8.0, 0.0 );


	// Apply the camera to the view.
	d_camera.applyCamera();

	// Get the view pos/orientation from the camera.
	f00Point3D viewPos( d_camera.x(), d_camera.y(), d_camera.z() );
	f00Quat viewOrient( d_camera.rot() );

	// Set up the light's properties.
	GLfloat light0_Pos[] = { 1.0, 0.0, 0.0, 0.0 };
	glLightfv( GL_LIGHT0, GL_POSITION, light0_Pos );
	GLfloat light0_Ambient[] = { 0.025, 0.025, 0.025, 0.0 };
	glLightfv( GL_LIGHT0, GL_AMBIENT, light0_Ambient );

	// Reset our state.
	glDepthMask( GL_TRUE );
	glDisable( GL_TEXTURE_2D );
	glEnable( GL_LIGHTING );
	glDisable( GL_BLEND );

	//
	// Draw something.
	//

	// Update our tentacle....
	f00Tentacle* pTentacle = dynamic_cast< f00Tentacle* >( d_pBoneSystem );
	for( int bone = 1; bone < pTentacle->countBones(); bone++ )
		pTentacle->getBone( bone )->d_orientation.set( f00Quat( 90.0 * sin( ( d_timeBase.getCurrentFrameBase() + d_timeBase.getCurrentFrameOffset() ) * 0.333 * M_PI * 2.0 ), 0.0, 1.0, 0.0 ) );

	// Update the angle.
	if( d_autoRotate )
	{
		d_autoViewAngle += lastFrameDeltaSeconds * -30.0;
		d_viewAngle = d_autoViewAngle;
	}
	d_pBoneSystem->rotTo( f00Quat( -90, 1.0, 0.0, 0.0 ) );
	d_pBoneSystem->rotBy( f00Quat( d_viewAngle, 0.0, 1.0, 0.0 ) );

	// Draw it.
	d_pBoneSystem->render( viewPos, viewOrient, d_timeBase );


	//
	// Pop into ortho mode for the UI shit.
	//

	glMatrixMode( GL_PROJECTION );
	glPushMatrix();
	glLoadIdentity();
	glOrtho( 0.0, 10.0, 0.0, 10.0, -1.0, 1.0 );
	glMatrixMode( GL_MODELVIEW );
	glLoadIdentity();

	glDisable( GL_LIGHTING );
	glDisable( GL_TEXTURE_2D );
	glPolygonMode( GL_FRONT, GL_FILL );
	glBegin( GL_QUADS );

		float factor;

		factor = pTentacle->baseRadius() / 10.0;
		glColor3f( 1.0, 0.0, 0.0 );
		glVertex2f( 1.0 + 0.0, 1.0 );
		glVertex2f( 1.0 + 0.1, 1.0 );
		glVertex2f( 1.0 + 0.1, 1.0 + factor );
		glVertex2f( 1.0 + 0.0, 1.0 + factor );
		glColor3f( 0.5, 0.0, 0.0 );
		glVertex2f( 1.0 + 0.0, 1.0 + factor );
		glVertex2f( 1.0 + 0.1, 1.0 + factor );
		glVertex2f( 1.0 + 0.1, 2.0 );
		glVertex2f( 1.0 + 0.0, 2.0 );

		factor = pTentacle->length() / 100.0;
		glColor3f( 1.0, 0.0, 0.0 );
		glVertex2f( 1.0 + 0.2, 1.0 );
		glVertex2f( 1.0 + 0.3, 1.0 );
		glVertex2f( 1.0 + 0.3, 1.0 + factor );
		glVertex2f( 1.0 + 0.2, 1.0 + factor );
		glColor3f( 0.5, 0.0, 0.0 );
		glVertex2f( 1.0 + 0.2, 1.0 + factor );
		glVertex2f( 1.0 + 0.3, 1.0 + factor );
		glVertex2f( 1.0 + 0.3, 2.0 );
		glVertex2f( 1.0 + 0.2, 2.0 );

		factor = pTentacle->boneLengthRatio();
		glColor3f( 1.0, 0.0, 0.0 );
		glVertex2f( 1.0 + 0.4, 1.0 );
		glVertex2f( 1.0 + 0.5, 1.0 );
		glVertex2f( 1.0 + 0.5, 1.0 + factor );
		glVertex2f( 1.0 + 0.4, 1.0 + factor );
		glColor3f( 0.5, 0.0, 0.0 );
		glVertex2f( 1.0 + 0.4, 1.0 + factor );
		glVertex2f( 1.0 + 0.5, 1.0 + factor );
		glVertex2f( 1.0 + 0.5, 2.0 );
		glVertex2f( 1.0 + 0.4, 2.0 );

		factor = pTentacle->boneRadiusRatio();
		glColor3f( 1.0, 0.0, 0.0 );
		glVertex2f( 1.0 + 0.6, 1.0 );
		glVertex2f( 1.0 + 0.7, 1.0 );
		glVertex2f( 1.0 + 0.7, 1.0 + factor );
		glVertex2f( 1.0 + 0.6, 1.0 + factor );
		glColor3f( 0.5, 0.0, 0.0 );
		glVertex2f( 1.0 + 0.6, 1.0 + factor );
		glVertex2f( 1.0 + 0.7, 1.0 + factor );
		glVertex2f( 1.0 + 0.7, 2.0 );
		glVertex2f( 1.0 + 0.6, 2.0 );

	glEnd();

	glColor3f( 1.0, 1.0, 1.0 );
	glMatrixMode( GL_PROJECTION );
	glPopMatrix();
	glMatrixMode( GL_MODELVIEW );
	glLoadIdentity();


	// Done, eh?
	glutSwapBuffers();

	// Next!
	glutPostRedisplay();
}


// If the window is resized, we need to recompute our viewport and aspect ratio.
void
reshapeFunc( int w, int h )
{
	glViewport( 0, 0, w, h );

	glMatrixMode( GL_PROJECTION );
	glLoadIdentity();

	// 50.0 degree FOV, aspect correction, near clip at 1.0, far clip at 1000.0.
	if( h < 1 )
		h = 1;
	gluPerspective( 50.0, (double)w / (double)h, 1.0, 1000.0 );

	glMatrixMode( GL_MODELVIEW );
}


void
idleFunc()
{
	// If we're idle, we might as well draw something.
	glutPostRedisplay();
}


void
keyboardFunc( unsigned char key, int x, int y )
{
	f00Tentacle* pTentacle = dynamic_cast< f00Tentacle* >( d_pBoneSystem );
	float baseRadius( pTentacle->baseRadius() );
	float length( pTentacle->length() );
	float boneLengthRatio( pTentacle->boneLengthRatio() );
	float boneRadiusRatio( pTentacle->boneRadiusRatio() );

	switch( key )
	{
		case 27:		// ESC
			processExitKey();
			break;

		case '[':
		case '{':
			d_autoRotate = false;
			d_viewAngle += 5.0;
			break;

		case ']':
		case '}':
			d_autoRotate = false;
			d_viewAngle -= 5.0;
			break;


		case '\\':
		case '|':
			d_autoRotate = true;
			d_autoViewAngle = d_viewAngle;
			break;


		case 'b':
		case 'B':
			d_pBoneSystem->toggleShowBonesAsLines();
			break;

		case 'w':
		case 'W':
			d_pBoneSystem->toggleShowWireframe();
			break;

		case 't':
		case 'T':
			pTentacle->setTextured( !pTentacle->getTextured() );
			break;


		case 'a':
		case 'A':
			pTentacle->setParameters(	baseRadius + 0.1,
												length,
												boneLengthRatio,
												boneRadiusRatio );
			break;

		case 'z':
		case 'Z':
			pTentacle->setParameters(	baseRadius - 0.1,
												length,
												boneLengthRatio,
												boneRadiusRatio );
			break;


		case 's':
		case 'S':
			pTentacle->setParameters(	baseRadius,
												length + 1.0,
												boneLengthRatio,
												boneRadiusRatio );
			break;

		case 'x':
		case 'X':
			pTentacle->setParameters(	baseRadius,
												length - 1.0,
												boneLengthRatio,
												boneRadiusRatio );
			break;


		case 'd':
		case 'D':
			pTentacle->setParameters(	baseRadius,
												length,
												boneLengthRatio + 0.1,
												boneRadiusRatio );
			break;

		case 'c':
		case 'C':
			pTentacle->setParameters(	baseRadius,
												length,
												boneLengthRatio - 0.1,
												boneRadiusRatio );
			break;


		case 'f':
		case 'F':
			pTentacle->setParameters(	baseRadius,
												length,
												boneLengthRatio,
												boneRadiusRatio + 0.1 );
			break;

		case 'v':
		case 'V':
			pTentacle->setParameters(	baseRadius,
												length,
												boneLengthRatio,
												boneRadiusRatio - 0.1 );
			break;


		case '1':
			d_pTentacle1->setTextured( pTentacle->getTextured() );
			d_pTentacle1->setShowBonesAsLines( pTentacle->getShowBonesAsLines() );
			d_pTentacle1->setShowWireframe( pTentacle->getShowWireframe() );
			d_pBoneSystem = d_pTentacle1;
			break;

		case '2':
			d_pTentacle2->setTextured( pTentacle->getTextured() );
			d_pTentacle2->setShowBonesAsLines( pTentacle->getShowBonesAsLines() );
			d_pTentacle2->setShowWireframe( pTentacle->getShowWireframe() );
			d_pBoneSystem = d_pTentacle2;
			break;

		case '3':
			d_pTentacle3->setTextured( pTentacle->getTextured() );
			d_pTentacle3->setShowBonesAsLines( pTentacle->getShowBonesAsLines() );
			d_pTentacle3->setShowWireframe( pTentacle->getShowWireframe() );
			d_pBoneSystem = d_pTentacle3;
			break;

		case '4':
			d_pTentacle4->setTextured( pTentacle->getTextured() );
			d_pTentacle4->setShowBonesAsLines( pTentacle->getShowBonesAsLines() );
			d_pTentacle4->setShowWireframe( pTentacle->getShowWireframe() );
			d_pBoneSystem = d_pTentacle4;
			break;

		case '5':
			d_pTentacle5->setTextured( pTentacle->getTextured() );
			d_pTentacle5->setShowBonesAsLines( pTentacle->getShowBonesAsLines() );
			d_pTentacle5->setShowWireframe( pTentacle->getShowWireframe() );
			d_pBoneSystem = d_pTentacle5;
			break;

	}
}


// Stuff to do on initialization (once).
void
init()
{
	glCullFace( GL_BACK );
	glEnable( GL_CULL_FACE );

	glEnable( GL_LIGHTING );
	glEnable( GL_LIGHT0 );

	glEnable( GL_DEPTH_TEST );

	glEnable( GL_COLOR_MATERIAL );

	// Establish callbacks.
	glutDisplayFunc( displayFunc );
	glutReshapeFunc( reshapeFunc );
	glutIdleFunc( idleFunc );
	glutKeyboardFunc( keyboardFunc );
}


// Stuff to do on un-initialization (once).
void
uninit()
{
	// Un-establish callbacks.
//	glutDisplayFunc( NULL );	// Not allowed in GLUT 3.0
	glutReshapeFunc( NULL );
	glutIdleFunc( NULL );
	glutKeyboardFunc( NULL );
}


int
main( int argc, char* argv[] )
{

#if __BORLANDC__ >= 0x0530
	// Work around for a Borland bug in the FPU error masking code....  ARGH!
	WORD goodFlag( 0x133F );
	asm {	FLDCW goodFlag	}
#endif
	strcpy(path,argv[0]);//jun
	glutInit( &argc, argv );
	glutInitDisplayMode( GLUT_DOUBLE | GLUT_DEPTH | GLUT_RGB );
	glutInitWindowSize( 640, 480 );
	glutInitWindowPosition( 10, 50 );

	d_mainWindowID = glutCreateWindow( argv[ 0 ] );
	glutSetWindowTitle( "Bones - Just another bone demo..." );

	// User init stuff, post window-creation.
	init();

	// Enter main loop, never to return (ie: use exit( 0 ) to exit).
	// FIXME  We may want to put some sort of exception handler here?
	glutMainLoop();

	return 0;
}



