#ifndef f00BoneSystemH
#define f00BoneSystemH


// System includes.
#include <GL/gl.h>
#include <vector>

// Local includes.
#include "f00QuatObject.h"



class f00BoneSystem : public f00QuatObject
{

	public:

		f00BoneSystem();

		~f00BoneSystem();


	// Virtuals.
	public:

		void
		renderObject( const f00Point3D& viewPos, const f00Quat& viewDir, const f00TimeBase& timeBase );


	// Accessors (parametrics).
	public:

		bool
		getShowBonesAsLines() const
		{
			return d_showBonesAsLines;
		}

		void
		setShowBonesAsLines( bool show = true )
		{
			d_showBonesAsLines = show;
		}

		void
		toggleShowBonesAsLines()
		{
			d_showBonesAsLines = !d_showBonesAsLines;
		}


		bool
		getShowWireframe() const
		{
			return d_showWireframe;
		}

		void
		setShowWireframe( bool wireframe = true )
		{
			d_showWireframe = wireframe;
		}

		void
		toggleShowWireframe()
		{
			d_showWireframe = !d_showWireframe;
		}


	// Parametrics.
	private:

		bool											d_showBonesAsLines;
		bool											d_showWireframe;


	// MAJOR FIXME  This is hacked in.
	protected:


		class LinkInfo;

		
		// FIXME Move to geometry manager (f00Scene?)
		struct VertInfo
		{
			f00Point3D								d_vertOrg;
			f00Point3D								d_texcOrg;
		};
		std::vector< VertInfo >					d_vertInfoList;

		// FIXME Move to geometry manager (f00Scene?)
		struct ElementInfo
		{
			GLenum									d_elemEntryType;
			std::vector< GLuint >				d_elemEntryList;
		};
		std::vector< ElementInfo* >			d_elemList;


		// FIXME Cleanup required.
		struct BoneInfo
		{
			float										d_length;
			float										d_baseRadius;
			f00Quat									d_orientation;
			f00Point3D								d_orgBase;
			f00Point3D								d_orgEnd;
			BoneInfo*								d_pParent;
			std::vector< LinkInfo* >			d_linkList;
		};

		// FIXME Clean this shit up!
		class LinkInfo
		{
			public:
				LinkInfo( BoneInfo* pBI, float weight, GLuint vertIndex )
				:	d_pBI( pBI ),
					d_weight( weight ),
					d_vertIndex( vertIndex )
				{
				}

				BoneInfo*							d_pBI;
				float									d_weight;
				GLuint								d_vertIndex;
		};


	private:

		std::vector< BoneInfo* >				d_boneList;


	public:

		int
		countBones();

		void
		addBone( f00BoneSystem::BoneInfo* pBI );

		f00BoneSystem::BoneInfo*
		getBone( int index );

		void
		dropBone( int index );


};


#endif

