
#ifdef __BORLANDC__
	// Borland stuff.
	#include <windows.h>
	#pragma hdrstop
#endif


// Primary include.
#include "f00FileLoader.h"

// System includes.
#include <fstream.h>
#include <sys/stat.h>



f00FileLoader::f00FileLoader( const char* pFileName )
:	d_lenBuffer( 0 ),
	d_pBuffer( 0 )
{
	load( pFileName );
}


f00FileLoader::~f00FileLoader()
{
	discard();
}


bool
f00FileLoader::load( const char* pFileName )
{
	discard();

	if( pFileName == 0 )
		return false;

	struct stat statBuffer;
	if( stat( pFileName, &statBuffer ) != 0 )
		return false;

	d_lenBuffer = statBuffer.st_size;
	if( d_lenBuffer <= 0 )
		return false;

	d_pBuffer = new char[ d_lenBuffer ];

	ifstream is( pFileName, ios::in | ios::binary );
	if( !is )
	{
		discard();
		return false;
	}
	is.read( (char*)d_pBuffer, d_lenBuffer );

	return true;
}


void
f00FileLoader::discard()
{
	delete[] d_pBuffer;
	d_pBuffer = 0;
	d_lenBuffer = 0;
}


int
f00FileLoader::length() const
{
	return d_lenBuffer;
}


const char*
f00FileLoader::access() const
{
	return d_pBuffer;
}

const char*
f00FileLoader::extract()
{
	const char* pRetBuffer = d_pBuffer;
	d_pBuffer = 0;
	d_lenBuffer = 0;
	return pRetBuffer;
}



