
#ifdef __BORLANDC__
	// Borland stuff.
	#include <windows.h>
	#pragma hdrstop
#endif


// Primary include.
#include "f00ImageLoader.h"

// System includes.
#include <assert.h>



f00ImageLoader::f00ImageLoader()
:	d_pImageRGBA( 0 )
{
	resetRGBA();
}


f00ImageLoader::~f00ImageLoader()
{
	resetRGBA();
}


int
f00ImageLoader::getWidth() const
{
	return d_imageWidth;
}


int
f00ImageLoader::getHeight() const
{
	return d_imageHeight;
}


GLubyte*
f00ImageLoader::getRGBA( int& width, int& height ) const
{
	if( d_pImageRGBA == 0 )
		return 0;
	width = d_imageWidth;
	height = d_imageHeight;
	return d_pImageRGBA;
}


GLubyte*
f00ImageLoader::extractRGBA( int& width, int& height )
{
	GLubyte* pReturn = getRGBA( width, height );
	d_pImageRGBA = 0;
	resetRGBA();
	return pReturn;
}


void
f00ImageLoader::resetRGBA()
{
	delete d_pImageRGBA;
	d_pImageRGBA = 0;
	d_imageWidth = -1;
	d_imageHeight = -1;
}


void
f00ImageLoader::setSize( int width, int height )
{
	d_imageWidth = width;
	d_imageHeight = height;
}


void
f00ImageLoader::setRGBA( GLubyte* pNewRGBA )
{
	assert( d_pImageRGBA == 0 );
	d_pImageRGBA = pNewRGBA;
}



