#ifndef f00ImageLoaderH
#define f00ImageLoaderH


// System includes.
#include <GL/gl.h>

// Local includes.
#include "f00FileLoader.h"



class f00ImageLoader
{

	public:

		f00ImageLoader();

		virtual
		~f00ImageLoader();


	public:

		// Must override!  Ownership stays outside.
		virtual bool
		loadImage( const char* pData, int lenData ) = 0;

		int
		getWidth() const;

		int
		getHeight() const;

		GLubyte*
		getRGBA( int& width, int& height ) const;

		GLubyte*
		extractRGBA( int& width, int& height );

		void
		resetRGBA();


	protected:

		void
		setSize( int width, int height );

		void
		setRGBA( GLubyte* pNewRGBA );


	private:

		int						d_imageWidth;
		int						d_imageHeight;

		GLubyte*					d_pImageRGBA;


};


#endif

