#ifndef f00TentacleH
#define f00TentacleH


// System includes.
#include <GL/gl.h>

// Local includes.
#include "f00BoneSystem.h"



class f00TextureObject;
class f00Tentacle : public f00BoneSystem
{

	public:

		f00Tentacle( f00TextureObject* pTexture, int boneCount, int stacksPerBone, int stacksPerCap, int slicesPerStack, float baseRadius = 1.0, float length = 10.0, float boneLengthRatio = 1.0, float boneRadiusRatio = 1.0 );

		~f00Tentacle();


	public:

		float
		baseRadius() const						{ return d_baseRadius; }

		float
		length() const								{ return d_length; }

		float
		boneLengthRatio() const					{ return d_boneLengthRatio; }

		float
		boneRadiusRatio() const					{ return d_boneRadiusRatio; }

		bool
		getTextured() const						{ return d_isTextured; }

		void
		setTextured( bool setTo )				{ d_isTextured = setTo; }


		void
		setParameters( float baseRadius, float length, float boneLengthRatio, float boneRadiusRatio );

		void
		renderObject( const f00Point3D& viewPos, const f00Quat& viewDir, const f00TimeBase& timeBase );


	private:

		int											d_boneCount;
		int											d_stacksPerBone;
		int											d_stacksPerCap;
		int											d_slicesPerStack;

		float											d_baseRadius;
		float											d_length;
		float											d_boneLengthRatio;
		float											d_boneRadiusRatio;

		f00TextureObject*							d_pTexture;
		bool											d_isTextured;


};


#endif

